#ifndef PLUGKIT_STREAM_BUFFER_H
#define PLUGKIT_STREAM_BUFFER_H

#include <memory>

namespace plugkit {
class StreamBuffer final {
public:
  ~StreamBuffer();
  size_t write(const char *data, size_t length) const;
  size_t read(char *data, size_t max);

private:
  StreamBuffer();

public:
  friend class Private;
  class Private;

private:
  std::unique_ptr<Private> d;
};
}

#endif
